<?php
/**************************************************
  Coppermine 1.5.x Plugin - anythingslider
  *************************************************
  Copyright (c) 2013 Mykee (www.acegem.hu)
  *************************************************
  This plugin based on AnythingSlider JQuery script.
  A very robust jQuery-based slider plugin. Need to
  link to a specific slide? No problem. Like a choice
  of themes? Got it. Need callbacks for when specific
  slider actions happen? Sure. Need custom tab names?
  You got it. Need more than one slider per page? Easy.
  More information and license here: https://github.com/CSS-Tricks/AnythingSlider
  ************************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/anythingslider/codebase.php $
  $Revision: 6994 $
  $LastChangedBy: mykee $
  $Date: 2013-08-10 23:05:10 +0100 (Sat, 10 Aug 2013) $
  **************************************************/
  
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}


// Add plugin_install action
$thisplugin->add_action('plugin_install','anythingslider_install');
// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','anythingslider_uninstall');


function anythingslider_noindex () {
  global $superCage;
   if ($superCage->get->keyExists('cat') or $superCage->get->keyExists('file')) {
      return "1";
    } else {
      return "0";    
    }
}
$anythingslider_noindex = anythingslider_noindex();

if ($anythingslider_noindex == "0"){
// Add filter for page head
$thisplugin->add_action('page_start','anythingslider_head');
// Add search display action
$thisplugin->add_filter('plugin_block','anythingslider_mainpage');
//Add plus styles for metas
$thisplugin->add_filter('gallery_header','anythingslider_header_addons');
//Add script to footer
$thisplugin->add_filter('gallery_footer','anythingslider_footer_addons');
}


// include some stuff in page header
function anythingslider_head()
{        
    global $ANYTHINGSLIDERSET, $CONFIG, $CPG_PHP_SELF, $JS;
    require ('./plugins/anythingslider/include/load_anythingsliderset.php');
    // only insert stuff if we're on album list page
    $anythingslider_pages_array = array('index.php');
    if (in_array($CPG_PHP_SELF, $anythingslider_pages_array) == TRUE)
    {
         
      if($ANYTHINGSLIDERSET['anythingslider_jquery'] == 1) {
         //Replace old JQuery to newer
        if (in_array('js/jquery-1.3.2.js', $JS['includes']) == TRUE) {
            $key = array_search('js/jquery-1.3.2.js', $JS['includes']);
            unset($JS['includes'][$key]);
            $key = array_search('js/jquery.greybox.js', $JS['includes']);
            unset($JS['includes'][$key]);
            $key = array_search('js/jquery.elastic.js', $JS['includes']);
            unset($JS['includes'][$key]);
            array_unshift($JS['includes'][] = "plugins/anythingslider/js/jquery.min.js");
            array_unshift($JS['includes'][] = "js/jquery.greybox.js");
            array_unshift($JS['includes'][] = "js/jquery.elastic.js");
        } else {
          //No replace just insert
          $JS['includes'][] = "plugins/anythingslider/js/jquery.min.js";
        }
      } 
    }
}


/* Header style addons */
function anythingslider_header_addons($html)
{ 
    global $thisplugin,$ANYTHINGSLIDERSET,$CONFIG,$CPG_PHP_SELF;

$anythingslider_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $anythingslider_pages_array) == TRUE)
 { 
    
    $width = $ANYTHINGSLIDERSET['anythingslider_width'];
    $container = $ANYTHINGSLIDERSET['anythingslider_container']."px";
    $sliderid = $ANYTHINGSLIDERSET['anythingslider_sliderid'];
    $divclass = $ANYTHINGSLIDERSET['anythingslider_divclass'];
    $height = $ANYTHINGSLIDERSET['anythingslider_height']."px";
    
    if ($ANYTHINGSLIDERSET['anythingslider_fixheight'] == 1) {
      $fixwidth = "width: auto;";
      $fixheight = "max-height: $height;"; 
    } else { 
      $fixwidth = "width: 100%;";
      $fixheight = "";
    }
    
    
   $cssblock =  <<< EOT
<script src="plugins/anythingslider/js/jquery.easing.1.2.js"></script>
<link rel="stylesheet" href="plugins/anythingslider/css/anythingslider.css" type="text/css" media="screen" />
<script src="plugins/anythingslider/js/jquery.anythingslider.min.js"></script>
<link rel="stylesheet" href="plugins/anythingslider/css/animate.css" type="text/css" media="screen" />
EOT;

/* Caption FX */
if ($ANYTHINGSLIDERSET['anythingslider_caption'] == 1){
$cssblock .= "\n". <<< EOT
<script src="plugins/anythingslider/js/jquery.anythingslider.fx.min.js"></script>
EOT;
}
   
/* Themes */ 
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'metallic'){
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/theme-metallic.css" type="text/css" media="screen" />
EOT;
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'minimalistround'){
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/theme-minimalist-round.css" type="text/css" media="screen" />
EOT;
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'minimalistsquare'){
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/theme-minimalist-square.css" type="text/css" media="screen" />
EOT;
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'construction'){
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/theme-construction.css" type="text/css" media="screen" />
EOT;
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'csportfolio'){
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/theme-cs-portfolio.css" type="text/css" media="screen" />
EOT;
}
 
$cssblock .= "\n". <<< EOT
<link rel="stylesheet" href="plugins/anythingslider/css/main.css" type="text/css" media="screen" />
<style type="text/css">
EOT;

if ($ANYTHINGSLIDERSET['anythingslider_container'] != ""){
$cssblock .= "\n". <<< EOT
.$divclass {
  position:relative;
  margin: 0px auto;
  max-width: $container; 
}
EOT;
}

$cssblock .= "\n". <<< EOT
#$sliderid {
  width: $width;
  height: $height;
}
#$sliderid img {
  $fixwidth
  height: 100%;
  $fixheight
}
EOT;

if ($ANYTHINGSLIDERSET['anythingslider_rescontent'] == "true"){
$cssblock .= "\n". <<< EOT
#$sliderid img {
  width: 100%; 
}
EOT;
}

if ($ANYTHINGSLIDERSET['anythingslider_caption'] != "0"){
$cssblock = $cssblock."\n". <<< EOT

/* images with caption */
#$sliderid img {
 $fixheight
}
 
 /* position the panels so the captions appear correctly */
 #$sliderid .panel { position: relative; }
 /* captions */
 #$sliderid .caption-top, #$sliderid .caption-right,
 #$sliderid .caption-bottom, #$sliderid .caption-left {
  background: #000;
  color: #fff;
  padding: 10px;
  margin: 0;
  position: relative;
  z-index: 10;
  opacity: .8;
  filter: alpha(opacity=80);
 }
 /* Top caption - padding is included in the width (480px here, 500px in the script), same for height */
 #$sliderid .caption-top {
  left: 0;
  top: 0;
  width: 480px; 
/*  height: 30px;*/
 }
 /* Right caption - padding is included in the width (130px here, 150px in the script), same for height */
 #$sliderid .caption-right {
  right: 0;
  bottom: 0;
  width: 130px;
  height: 180px;
 }
 /* Bottom caption - padding is included in the width (480px here, 500px in the script), same for height */
 #$sliderid .caption-bottom {
  left: 0;
  bottom: 0;
  width: 480px;
  height: 30px;
 }
 /* Left caption - padding is included in the width (130px here, 150px in the script), same for height */
 #$sliderid .caption-left {
  left: 0;
  bottom: 0;
  width: 130px;
  height: 180px;
 }
 /* Caption close button */
 .caption-top .close, .caption-right .close,
 .caption-bottom .close, .caption-left .close {
  font-size: 80%;
  cursor: pointer;
  float: right;
  display: inline-block;
 }

EOT;
}

$cssblock = $cssblock."\n". <<< EOT
</style>
EOT;
    $htmlhead = $cssblock."</head>";
    $html = str_replace("</head>", $htmlhead, $html);    
}
  return $html;
}


/* String replace */

function anythingslider_stringreplace ($string) {
  
  $string = strtolower(trim($string , "\t\n\r\0\x0B" ));
  $chars = array("á", "é", "ú", "ő", "ó", "ü", "ö", "í", "Á", "É", "Ú", "Ő", "Ó", "Ü", "Ö","Í");
  $charsrep = array("a", "e", "u", "o", "o", "u", "o", "i", "A", "E", "U", "O", "O", "U", "O","I");
  $allowed = "/[^a-z0-9]/i";
  $string = str_replace($chars, $charsrep, $string);
  $string = preg_replace($allowed,"",$string);
  
  return $string;
}



/* Plugin main */
function anythingslider_mainpage($html)
{
 global $CONFIG,$RESTRICTEDWHERE,$lang_plugin_anythingslider,$FORBIDDEN_SET,$ANYTHINGSLIDERSET,$lang_meta_album_names,$lang_common,$META_ALBUM_SET, $CPG_PHP_SELF,$matches;

 // only insert stuff if we're on album list page
    require ('./plugins/anythingslider/include/init.inc.php');
    require ('./plugins/anythingslider/include/load_anythingsliderset.php');
    
 $anythingslider_pages_array = array('index.php');
 $sliderid = $ANYTHINGSLIDERSET['anythingslider_sliderid'];
 $divclass = $ANYTHINGSLIDERSET['anythingslider_divclass'];
 $cappos = $ANYTHINGSLIDERSET['anythingslider_cappos'];
 
 if (in_array($CPG_PHP_SELF, $anythingslider_pages_array) == TRUE)
 {
   get_meta_album_set();      
        if($matches[1] != 'anythingslider') {
          return $matches;
        }   
/* Start anythingslider */ 
     // maximum pics to show
      $anythingsliderlimit=$ANYTHINGSLIDERSET['anythingslider_numberofpics'];
   
    

?>
<!-- anythingslider Content Start -->
            <div id="anythingcontainer" class="<?php echo $divclass ?>" style="display:none">
            <ul id="<?php echo $sliderid ?>">
            
<?php
  // request of your database
  $anythingslider_pics='';
   
   if ($ANYTHINGSLIDERSET['anythingslider_oriental'] == 1) {
    $orifilter = " AND pwidth > pheight ";
   } else if ($ANYTHINGSLIDERSET['anythingslider_oriental'] == 2) {
    $orifilter = " AND pwidth < pheight ";
   } else {
    $orifilter = "";
   }
    
    // This maybe fixed the fix height option, but not helped on every time
    if ($ANYTHINGSLIDERSET['anythingslider_fixheight'] == 1) {
    $heightfixer= "AND pheight > '{$ANYTHINGSLIDERSET['anythingslider_height']}' AND pwidth > '{$ANYTHINGSLIDERSET['anythingslider_height']}*2'";
    } else {
    $heightfixer= '';
    }  
   
        // request string for meta album toprated
        if ($ANYTHINGSLIDERSET['anythingslider_album'] == "toprated") {
          $anythingslider_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND r.votes >= '{$CONFIG['min_votes_for_rating']}' $heightfixer $META_ALBUM_SET ORDER BY pic_rating DESC, r.votes DESC, pid DESC LIMIT $anythingsliderlimit";
        }
        // request string for meta album most viewed
        else if ($ANYTHINGSLIDERSET['anythingslider_album'] == "topn") {
          $anythingslider_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND hits > 0 $heightfixer $META_ALBUM_SET ORDER BY hits DESC, filename LIMIT $anythingsliderlimit";  
        }
        // request string for meta album last uploads
        else if ($ANYTHINGSLIDERSET['anythingslider_album'] == "lastup") {
          $anythingslider_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $heightfixer $META_ALBUM_SET ORDER BY pid DESC LIMIT $anythingsliderlimit";  
        }
        // request string for meta album random pics
        else
        {
        $anythingslider_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $heightfixer $META_ALBUM_SET ORDER BY RAND() LIMIT $anythingsliderlimit";
        } 
  // For reading result
  $anythingslider_rowset = array();        
  // Index of tab
  $i=0;
  // max height : will be 75px or 100px
  $max_height=0;
  // For each pic.....building javascript in php
  $anythingslider_minpics = 1;
  
  // result of request
  $anythingslider_result = cpg_db_query($anythingslider_query);

  while($anythingslider_row = mysql_fetch_array($anythingslider_result)){
  // reading pid of pic
  $anythingslider_key=$anythingslider_row['pid'];
  $album_title= $anythingslider_row['title'];
  $album_class = anythingslider_stringreplace ($anythingslider_row['title']);
  $album_id = $anythingslider_row['aid'];
                  
       
    // path of pic
    $anythingslider_file=get_pic_url($anythingslider_row,'thumb');
    $anythingslider_imgfile=get_pic_url($anythingslider_row,$ANYTHINGSLIDERSET['anythingslider_pictype']);
    if ($anythingslider_imgfile == "images/thumbs/thumb_nopic.png" || $anythingslider_file == "images/thumbs/thumb_nopic.png") $anythingslider_imgfile="";
    $anythingslider_pictitle = $anythingslider_row['14'];
    
    // link of pic
    if ($anythingslider_imgfile !="") {
        if($ANYTHINGSLIDERSET['anythingslider_caption'] == 1) {  
          $anythingslider_lien="<li><div class=\"".$cappos."\">".$anythingslider_pictitle."</div><a href=\"displayimage.php?album=".$album_id."&pid=".$anythingslider_key."#top_display_media\"><img src=\"".$anythingslider_imgfile."\" alt=\"".$anythingslider_pictitle."\"></a></li>";
          } else {
//              $anythingslider_lien="<div class=\"photo $album_class\">"."\n"."<span class=\"tiptip\" title=\"".$anythingslider_pictitle."<br />".$anythingslider_row['caption']."\"><a href=\"displayimage.php?pid=".$anythingslider_key."\"><img class=\"adipoli\" src=\"".$anythingslider_imgfile."\" border=\"0\" onclick=\"copyspeed=0;\" alt=\"".$anythingslider_pictitle."\" link=\"displayimage.php?pid=".$anythingslider_key."\" pid=\"".$anythingslider_key."\" /></span></a>"."\n"."</div>";
          $anythingslider_lien="<li><a href=\"displayimage.php?album=".$album_id."&pid=".$anythingslider_key."#top_display_media\"><img src=\"".$anythingslider_imgfile."\" alt=\"".$anythingslider_pictitle."\"></a></li>";
//       $anythingslider_lien="<li><img src=\"".$anythingslider_imgfile."\" alt=\"\"></li>";     
       }
    } else {
    $anythingslider_lien= "";
    }
    
    // building pictures
    $anythingslider_pics .= $anythingslider_lien."\n";

   }
    
  // free memory
  mysql_free_result($anythingslider_result);

?>
                                <?php echo $anythingslider_pics ?>
</ul>                            
</div>
<!-- anythingslider Content End -->                        
<?php
echo "\n";
  }
}

// Install
function anythingslider_install()
{
                global $CONFIG, $thisplugin;
                require 'include/sql_parse.php';

                // create table
                $db_schema = $thisplugin->fullpath . '/schema.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');

                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
                
                // insert default values
                $db_schema = $thisplugin->fullpath . '/basic.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
              
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
           return true;
}


// Unnstall and drop settings table
function anythingslider_uninstall()
{
        global $CONFIG;
        cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugin_anythingslider");
        return true;
}


// Add script to footer
function anythingslider_footer_addons($html) {

global $CONFIG,$ANYTHINGSLIDERSET,$CPG_PHP_SELF;


$anythingslider_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $anythingslider_pages_array) == TRUE)
 { 
  
   
    //Times
    $delay = 'delay: '. $ANYTHINGSLIDERSET['anythingslider_delay']*1000 .',';
    
    // AutoPlay
    $autoplay = 'autoPlay: '. $ANYTHINGSLIDERSET['anythingslider_autoplay'].','; 
    
    // Navigation
    $arrows = 'buildArrows: '. $ANYTHINGSLIDERSET['anythingslider_arrows'].',';
    $navigation = 'buildNavigation: '. $ANYTHINGSLIDERSET['anythingslider_navigation'].',';
    $startstop = 'buildStartStop: '. $ANYTHINGSLIDERSET['anythingslider_startstop'].',';
    $keyboard = 'enableKeyboard: '. $ANYTHINGSLIDERSET['anythingslider_keyboard'].',';
    
    //Resize
    $rescontent = 'resizeContents: '. $ANYTHINGSLIDERSET['anythingslider_rescontent'].',';
    
    //Addon parameters
    if ($ANYTHINGSLIDERSET['anythingslider_addon'] != ""){
    $addon = $ANYTHINGSLIDERSET['anythingslider_addon'];
    } else {
    $addon = '';
    }
    
    //Custom code
    $custcode = $ANYTHINGSLIDERSET['anythingslider_custcode'];
    
    if ($ANYTHINGSLIDERSET['anythingslider_sliderid'] != "") {
    $idtext = "'#".$ANYTHINGSLIDERSET['anythingslider_sliderid']."'";
    } else {
    $idtext = "'#slider1'";
    }
    
    $theme = '';

if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'metallic'){
$theme = 'theme: "metallic",';
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'minimalistround'){
$theme = 'theme: "minimalist-round",';
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'minimalistsquare'){
$theme = 'theme: "minimalist-square",';
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'construction'){
$theme = 'theme: "construction",';
}
if ($ANYTHINGSLIDERSET['anythingslider_theme'] == 'csportfolio'){
$theme = 'theme: "cs-portfolio",';
}

if($ANYTHINGSLIDERSET['anythingslider_stdcust'] == 1 || ($ANYTHINGSLIDERSET['anythingslider_stdcust'] == 0 && $custcode == "" )) {        
   $footblock = <<< EOT
<script type="text/javascript">
$(function(){
$("#anythingcontainer").show();

 $({$idtext})
  .anythingSlider({
//settings from plugin manager  
  {$theme}
  {$autoplay}
  {$delay}
  {$arrows}
  {$navigation}
  {$startstop}
  {$keyboard}
  {$rescontent}
  {$addon}
//Fixed parameters 
  hashTags: false
  })
EOT;

if($ANYTHINGSLIDERSET['anythingslider_caption'] == 1) { 
  $footblock .= <<< EOT
  .anythingSliderFx({
   // '.selector' : [ 'caption', 'distance/size', 'time', 'easing' ]
   // 'distance/size', 'time' and 'easing' are optional parameters
   '.caption-top'    : [ 'caption-Top', '50px' ],
   '.caption-right'  : [ 'caption-Right', '130px', '1000', 'easeOutBounce' ],
   '.caption-bottom' : [ 'caption-Bottom', '50px' ],
   '.caption-left'   : [ 'caption-Left', '130px', '1000', 'easeOutBounce' ]
  })
  /* add a close button (x) to the caption */
  .find('div[class*=caption]')
    .css({ position: 'absolute' })
    .prepend('<span class="close">X</span>')
    .find('.close').click(function(){
      var cap = $(this).parent(),
       ani = { bottom : -50 }; // bottom
      if (cap.is('.caption-top')) { ani = { top: -50 }; }
      if (cap.is('.caption-left')) { ani = { left: -150 }; }
      if (cap.is('.caption-right')) { ani = { right: -150 }; }
      cap.animate(ani, 400, function(){ cap.hide(); } );
    });
EOT;
}

  $footblock .= <<< EOT
});
</script>
EOT;

} else {
// Custom code from plugin manager
  $footblock = <<< EOT
<script type="text/javascript">
$(function(){
$("#anythingcontainer").show();
});
</script>
<script type="text/javascript">
{$custcode}
</script>
EOT;
}
    $htmlclose = $footblock."</body>";
    $html = str_replace("</body>", $htmlclose, $html);
}
    return $html;
}


?>